//import 'package:fluent_ui/fluent_ui.dart';
import 'package:flutter/material.dart';
//import 'package:hermogas_ecosistema_web/viewmodels/codigo_postal_view_model.dart';
import 'package:yoshi_papas_app/views/perfil/perfil_screen.dart';
import 'package:provider/provider.dart';
import '../themes/themes.dart';
import 'package:flutter/services.dart';

import 'viewmodels/viewmodels.dart';
import 'views/main/main_screen.dart';
import 'views/home/home_screen.dart';
import 'views/login/login_screen.dart';
import 'package:timezone/data/latest.dart' as tzdata;

void main() {
  WidgetsFlutterBinding.ensureInitialized();
  tzdata.initializeTimeZones();
  SystemChrome.setPreferredOrientations([
    DeviceOrientation.landscapeRight,
    DeviceOrientation.landscapeLeft,
  ]).then((_) {
    runApp(MultiProvider(providers: [
      ChangeNotifierProvider(create: (_) => LoginViewModel()),
      ChangeNotifierProvider(create: (_) => UsuariosViewModel()),
      ChangeNotifierProvider(create: (_) => ProfileViewModel()),
      ChangeNotifierProvider(create: (_) => CategoriaProductoViewModel()),
      ChangeNotifierProvider(create: (_) => ProductoViewModel()),
      ChangeNotifierProvider(create: (_) => TopingCategoriaViewModel()),
      ChangeNotifierProvider(create: (_) => MediaViewModel()),
      ChangeNotifierProvider(create: (_) => TopingViewModel()),
      // Agrega aquí cualquier otro provider que necesites
    ], child: const MyApp()));
  });
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});
  //ChangeNotifierProvider(create: (_) => AppTheme()),

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      locale: const Locale("en", "ES"),
      debugShowCheckedModeBanner: false,
      title: 'Yoshi Papas',
      theme: AppTheme.lightTheme,
      initialRoute: 'main',
      routes: {
        'main': (context) => const MainScreen(),
        'login': (context) => const LoginScreen(),
        'home': (context) => const HomeScreen(),
        'perfil': (context) => const PerfilScreen(),
      },
    );
  }
}
