import 'basico_model.dart';

class Pedido extends Basico {
  int? folio;
  int? estatus;
  String? comentarios;
  String? peticion;
  String? nombreCliente;
  int? idCliente;
  int? idMesa;
  int? terminado;
  int? cerrar;
  int? idUsuario;
  int? idModificador;
  int? idCancelado;

  Pedido({
    super.id,
    this.folio,
    this.estatus,
    this.comentarios,
    this.peticion,
    this.nombreCliente,
    this.idCliente,
    this.idMesa,
    this.terminado,
    this.cerrar,
    this.idUsuario,
    this.idModificador,
    this.idCancelado,
  });

  @override
  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'folio': folio,
      'estatus': estatus,
      'comentarios': comentarios,
      'peticion': peticion,
      'nombreCliente': nombreCliente,
      'idCliente': idCliente,
      'idMesa': idMesa,
      'terminado': terminado,
      'cerrar': cerrar,
      'idUsuario': idUsuario,
      'idModificador': idModificador,
      'idCancelado': idCancelado,
    }..addAll(super.toJson());
  }

  Pedido.fromJson(Map<String, dynamic> json) {
    super.parseJson(json);
    folio = Basico.parseInt(json['folio']);
    estatus = Basico.parseInt(json['estatus']);
    comentarios = Basico.parseString(json['comentarios']);
    peticion = Basico.parseString(json['peticion']);
    nombreCliente = Basico.parseString(json['nombreCliente']);
    idCliente = Basico.parseInt(json['idCliente']);
    idMesa = Basico.parseInt(json['idMesa']);
    terminado = Basico.parseInt(json['terminado']);
    cerrar = Basico.parseInt(json['cerrar']);
    idUsuario = Basico.parseInt(json['idUsuario']);
    idModificador = Basico.parseInt(json['idModificador']);
    idCancelado = Basico.parseInt(json['idCancelado']);
  }
}
