// ignore_for_file: use_build_context_synchronously

import 'package:flutter/material.dart';
import 'package:yoshi_papas_app/widgets/widgets.dart';
import 'package:provider/provider.dart';

import '../../models/models.dart';
import '../../viewmodels/viewmodels.dart';

class CategoriaProductoForm extends StatefulWidget {
  const CategoriaProductoForm({Key? key}) : super(key: key);

  @override
  State<CategoriaProductoForm> createState() => Formulario();
}

class Formulario extends State<CategoriaProductoForm> {
  final _nombre = TextEditingController();
  final _busquedaNombre = TextEditingController();

  @override
  void initState() {
    super.initState();
    Future(() async {
      Provider.of<CategoriaProductoViewModel>(context, listen: false)
          .setIsLoading(true);
      final mvm =
          Provider.of<CategoriaProductoViewModel>(context, listen: false);
      CategoriaProducto? modelo = mvm.selectedCategoriaProducto;
      if (modelo != null && modelo.id > 0) {
        setState(() {
          _nombre.text = modelo.nombre.toString();
        });
      }
      Provider.of<CategoriaProductoViewModel>(context, listen: false)
          .setIsLoading(false);
    });
  }

  @override
  void dispose() {
    super.dispose();
    _nombre.dispose();
  }

  @override
  Widget build(BuildContext context) {
    final mvm = Provider.of<CategoriaProductoViewModel>(context);
    if (mvm.isLoading) return const Cargando();
    final segmento = mvm.selectedCategoriaProducto;

    return Scaffold(
      appBar: encabezado(titulo: "Agregar categoría producto"),
      body: SingleChildScrollView(
        padding: const EdgeInsets.all(8),
        child: Column(
          children: [
            tarjeta(
              Padding(
                padding: const EdgeInsets.all(8),
                child: Column(
                  children: [
                    Row(
                      children: [
                        Expanded(
                          child: AppTextField(
                            maxLength: 100,
                            etiqueta: 'Nombre',
                            controller: _nombre,
                            hintText: 'Nombre de categoría producto',
                          ),
                        ),
                      ],
                    ),
                  ],
                ),
              ),
            ),
            const SizedBox(height: 15),
            boton("Guardar", () async {
              Provider.of<CategoriaProductoViewModel>(context, listen: false)
                  .setIsLoading(true);
              await mvm.addCategoriaProducto(
                nombre: _nombre.text,
              );
              Provider.of<CategoriaProductoViewModel>(context, listen: false)
                  .setIsLoading(false);
              if (context.mounted) {
                Navigator.pop(context);
              }
            }),
          ],
        ),
      ),
    );
  }
}
