import 'package:flutter/material.dart';
import 'package:yoshi_papas_app/widgets/widgets.dart';
import 'package:provider/provider.dart';

import '../../viewmodels/login_view_model.dart';

class HomeScreen extends StatefulWidget {
  const HomeScreen({super.key});

  @override
  Formulario createState() => Formulario();
}

class Formulario extends State<HomeScreen> {
  @override
  void initState() {
    super.initState();
    Future(() async {
      await Provider.of<LoginViewModel>(context, listen: false).setValores();
    });
  }

  @override
  Widget build(BuildContext context) {
    String nombre = Provider.of<LoginViewModel>(context).nombre;
    String correo = Provider.of<LoginViewModel>(context).correo;
    return Scaffold(
      backgroundColor: Colors.grey.shade200,
      drawer: AppDrawer(),
      appBar: AppBar(
        elevation: 0,
        title: const Text('Inicio'),
        actions: [usuarioHeader(nombre, correo)],
      ),
      body: const Center(
        child: Image(
          image: AssetImage('assets/JoshiLogo.png'),
          height: 200,
        ),
      ),
    );
  }
}
